// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/base"
	model "LAPP_ACURA_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ArtCheckRuleDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArtCheckRule的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-24 11:19:07
 *
 ******************************************************************************/
type ArtCheckRuleDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewArtCheckRuleDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ArtCheckRuleDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ArtCheckRuleDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-24 11:19:07
 *
 ******************************************************************************/
func NewArtCheckRuleDAOImplement(session *xorm.Session, plantNr int, userid string) *ArtCheckRuleDAOImplement {
	return &ArtCheckRuleDAOImplement{session, &meta.ArtCheckRule, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) InsertOne(entity *model.ArtCheckRule) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) DeleteOne(attriCode int, workLineId string, projectId string, subObject string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attriCode, workLineId, projectId, subObject}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) SelectOne(attriCode int, workLineId string, projectId string, subObject string) (*model.ArtCheckRule, error) {
	var data model.ArtCheckRule
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attriCode, workLineId, projectId, subObject}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) UpdateOne(entity *model.ArtCheckRule) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.Insert
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) Insert(entities *[]model.ArtCheckRule) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.Delete
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) Delete(entities *[]model.ArtCheckRule) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtCheckRule_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.Select
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArtCheckRule, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtCheckRule_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ArtCheckRule_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArtCheckRule, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.SelectCols
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) SelectCols(predicates []grmi.Predicate, orderByFields []grmi.Field, cloumns []string) ([]model.ArtCheckRule, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtCheckRule_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ArtCheckRule_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArtCheckRule, 0, 10)
	err := session.Cols(cloumns...).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtCheckRule_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ArtCheckRule_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ArtCheckRule, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.Update
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) Update(entities *[]model.ArtCheckRule) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ArtCheckRule, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtCheckRule_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ArtCheckRule_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.SelectByArtId
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) SelectByArtId(artId string, projectId string, attrCodeLi []int) ([]model.ArtCheckRule, error) {
	result := make([]model.ArtCheckRule, 0)
	parameters := []interface{}{impl.plantNr, projectId, model.MES_MATCH_ALL, artId}
	where := fmt.Sprintf("%s = ? and %s = ? and ( %s = ? or %s = ? )",
		meta.ArtCheckRule_PlantNr.ColumnName,
		meta.ArtCheckRule_ProjectId.ColumnName,
		meta.ArtCheckRule_SubObject.ColumnName,
		meta.ArtCheckRule_SubObject.ColumnName)

	err := impl.session.Table(impl.meta.TableName).Where(where, parameters...).In(meta.ArtCheckRule_AttriCode.SortColumnName, attrCodeLi).OrderBy(meta.ArtCheckRule_AttriCode.SortColumnName).Find(&result)
	return result, err
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtCheckRuleDAO.SelectByArtId
 *
 ******************************************************************************/
func (impl *ArtCheckRuleDAOImplement) SelectOperationCheckRule(artId string, attrCode int, projectId string) ([]model.ArtCheckRule, error) {
	result := make([]model.ArtCheckRule, 0)
	parameters := []interface{}{impl.plantNr, attrCode, projectId, model.MES_MATCH_ALL, artId}
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ? and ( %s = ? or %s = ? )",
		meta.ArtCheckRule_PlantNr.ColumnName,
		meta.ArtCheckRule_AttriCode.ColumnName,
		meta.ArtCheckRule_ProjectId.ColumnName,
		meta.ArtCheckRule_SubObject.ColumnName,
		meta.ArtCheckRule_SubObject.ColumnName)
	err := impl.session.Table(impl.meta.TableName).Where(where, parameters...).OrderBy(meta.ArtCheckRule_AttriCode.SortColumnName).Find(&result)
	return result, err
}
